## qemu-kvm 1.0+noroms

=== Makefile ===
# Makefile for QEMU.

# Always point to the root of the build tree (needs GNU make).
BUILD_DIR=$(CURDIR)

GENERATED_HEADERS = config-host.h trace.h qemu-options.def
ifeq ($(TRACE_BACKEND),dtrace)
GENERATED_HEADERS += trace-dtrace.h
endif
GENERATED_HEADERS += qmp-commands.h qapi-types.h qapi-visit.h
GENERATED_SOURCES += qmp-marshal.c qapi-types.c qapi-visit.c

ifneq ($(wildcard config-host.mak),)
# Put the all: rule here so that config-host.mak can contain dependencies.
all: build-all
include config-host.mak
include $(SRC_PATH)/rules.mak
config-host.mak: $(SRC_PATH)/configure
	@echo $@ is out-of-date, running configure
	@sed -n "/.*Configured with/s/[^:]*: //p" $@ | sh
else
config-host.mak:
	@echo "Please call configure before running make!"
	@exit 1
endif

# Don't try to regenerate Makefile or configure
# We don't generate any of them
Makefile: ;
configure: ;

.PHONY: all clean cscope distclean dvi html info install install-doc \
	pdf recurse-all speed tar tarbin test build-all

$(call set-vpath, $(SRC_PATH):$(SRC_PATH)/hw)

LIBS+=-lz $(LIBS_TOOLS)

ifdef BUILD_DOCS
DOCS=qemu-doc.html qemu-tech.html qemu.1 qemu-img.1 qemu-nbd.8 QMP/qmp-commands.txt
else
DOCS=
endif

SUBDIR_MAKEFLAGS=$(if $(V),,--no-print-directory) BUILD_DIR=$(BUILD_DIR)
SUBDIR_DEVICES_MAK=$(patsubst %, %/config-devices.mak, $(TARGET_DIRS))
SUBDIR_DEVICES_MAK_DEP=$(patsubst %, %/config-devices.mak.d, $(TARGET_DIRS))

config-all-devices.mak: $(SUBDIR_DEVICES_MAK)
	$(call quiet-command,cat $(SUBDIR_DEVICES_MAK) | grep =y | sort -u > $@,"  GEN   $@")

-include $(SUBDIR_DEVICES_MAK_DEP)

%/config-devices.mak: default-configs/%.mak
	$(call quiet-command,$(SHELL) $(SRC_PATH)/scripts/make_device_config.sh $@ $<, "  GEN   $@")
	@if test -f $@; then \
	  if cmp -s $@.old $@; then \
	    mv $@.tmp $@; \
	    cp -p $@ $@.old; \
	  else \
	    if test -f $@.old; then \
	      echo "WARNING: $@ (user modified) out of date.";\
	    else \
	      echo "WARNING: $@ out of date.";\
	    fi; \
	    echo "Run \"make defconfig\" to regenerate."; \
	    rm $@.tmp; \
	  fi; \
	 else \
	  mv $@.tmp $@; \
	  cp -p $@ $@.old; \
	 fi

defconfig:
	rm -f config-all-devices.mak $(SUBDIR_DEVICES_MAK)

-include config-all-devices.mak

build-all: $(DOCS) $(TOOLS) $(CHECKS) recurse-all

config-host.h: config-host.h-timestamp
config-host.h-timestamp: config-host.mak
qemu-options.def: $(SRC_PATH)/qemu-options.hx
	$(call quiet-command,sh $(SRC_PATH)/scripts/hxtool -h < $< > $@,"  GEN   $@")

SUBDIR_RULES=$(patsubst %,subdir-%, $(TARGET_DIRS))

subdir-%: $(GENERATED_HEADERS)
	$(call quiet-command,$(MAKE) $(SUBDIR_MAKEFLAGS) -C $* V="$(V)" TARGET_DIR="$*/" all,)

ifneq ($(wildcard config-host.mak),)
include $(SRC_PATH)/Makefile.objs
endif

$(common-obj-y): $(GENERATED_HEADERS)
subdir-libcacard: $(oslib-obj-y) $(trace-obj-y) qemu-timer-common.o

$(filter %-softmmu,$(SUBDIR_RULES)): $(trace-obj-y) $(common-obj-y) subdir-libdis

$(filter %-user,$(SUBDIR_RULES)): $(GENERATED_HEADERS) $(trace-obj-y) subdir-libdis-user subdir-libuser

ROMSUBDIR_RULES=$(patsubst %,romsubdir-%, $(ROMS))
romsubdir-%:
	$(call quiet-command,$(MAKE) $(SUBDIR_MAKEFLAGS) -C pc-bios/$* V="$(V)" TARGET_DIR="$*/",)

ALL_SUBDIRS=$(TARGET_DIRS) $(patsubst %,pc-bios/%, $(ROMS))

recurse-all: $(SUBDIR_RULES) $(ROMSUBDIR_RULES)

audio/audio.o audio/fmodaudio.o: QEMU_CFLAGS += $(FMOD_CFLAGS)

QEMU_CFLAGS+=$(CURL_CFLAGS)

QEMU_CFLAGS+=$(GLIB_CFLAGS)

ui/cocoa.o: ui/cocoa.m

ui/sdl.o audio/sdlaudio.o ui/sdl_zoom.o baum.o: QEMU_CFLAGS += $(SDL_CFLAGS)

ui/vnc.o: QEMU_CFLAGS += $(VNC_TLS_CFLAGS)

bt-host.o: QEMU_CFLAGS += $(BLUEZ_CFLAGS)

version.o: $(SRC_PATH)/version.rc config-host.h
	$(call quiet-command,$(WINDRES) -I. -o $@ $<,"  RC    $(TARGET_DIR)$@")

version-obj-$(CONFIG_WIN32) += version.o
######################################################################
# Support building shared library libcacard

.PHONY: libcacard.la install-libcacard
ifeq ($(LIBTOOL),)
libcacard.la:
	@echo "libtool is missing, please install and rerun configure"; exit 1

install-libcacard:
	@echo "libtool is missing, please install and rerun configure"; exit 1
else
libcacard.la: $(GENERATED_HEADERS) $(oslib-obj-y) qemu-timer-common.o $(addsuffix .lo, $(basename $(trace-obj-y)))
	$(call quiet-command,$(MAKE) $(SUBDIR_MAKEFLAGS) -C libcacard V="$(V)" TARGET_DIR="$*/" libcacard.la,)

install-libcacard: libcacard.la
	$(call quiet-command,$(MAKE) $(SUBDIR_MAKEFLAGS) -C libcacard V="$(V)" TARGET_DIR="$*/" install-libcacard,)
endif
######################################################################

qemu-img.o: qemu-img-cmds.h
qemu-img.o qemu-tool.o qemu-nbd.o qemu-io.o cmd.o qemu-ga.o: $(GENERATED_HEADERS)

tools-obj-y = qemu-tool.o $(oslib-obj-y) $(trace-obj-y) \
	qemu-timer-common.o cutils.o

qemu-img$(EXESUF): qemu-img.o $(tools-obj-y) $(block-obj-y)
qemu-nbd$(EXESUF): qemu-nbd.o $(tools-obj-y) $(block-obj-y)
qemu-io$(EXESUF): qemu-io.o cmd.o $(tools-obj-y) $(block-obj-y)

qemu-img-cmds.h: $(SRC_PATH)/qemu-img-cmds.hx
	$(call quiet-command,sh $(SRC_PATH)/scripts/hxtool -h < $< > $@,"  GEN   $@")

check-qint.o check-qstring.o check-qdict.o check-qlist.o check-qfloat.o check-qjson.o test-coroutine.o: $(GENERATED_HEADERS)

check-qint: check-qint.o qint.o $(tools-obj-y)
check-qstring: check-qstring.o qstring.o $(tools-obj-y)
check-qdict: check-qdict.o qdict.o qfloat.o qint.o qstring.o qbool.o qlist.o $(tools-obj-y)
check-qlist: check-qlist.o qlist.o qint.o $(tools-obj-y)
check-qfloat: check-qfloat.o qfloat.o $(tools-obj-y)
check-qjson: check-qjson.o $(qobject-obj-y) $(tools-obj-y)
test-coroutine: test-coroutine.o qemu-timer-common.o async.o $(coroutine-obj-y) $(tools-obj-y)

$(qapi-obj-y): $(GENERATED_HEADERS)
qapi-dir := $(BUILD_DIR)/qapi-generated
test-visitor.o test-qmp-commands.o qemu-ga$(EXESUF): QEMU_CFLAGS += -I $(qapi-dir)
qemu-ga$(EXESUF): LIBS = $(LIBS_QGA)

$(qapi-dir)/test-qapi-types.c $(qapi-dir)/test-qapi-types.h :\
$(SRC_PATH)/qapi-schema-test.json $(SRC_PATH)/scripts/qapi-types.py
	$(call quiet-command,$(PYTHON) $(SRC_PATH)/scripts/qapi-types.py -o "$(qapi-dir)" -p "test-" < $<, "  GEN   $@")
$(qapi-dir)/test-qapi-visit.c $(qapi-dir)/test-qapi-visit.h :\
$(SRC_PATH)/qapi-schema-test.json $(SRC_PATH)/scripts/qapi-visit.py
	$(call quiet-command,$(PYTHON) $(SRC_PATH)/scripts/qapi-visit.py -o "$(qapi-dir)" -p "test-" < $<, "  GEN   $@")
$(qapi-dir)/test-qmp-commands.h $(qapi-dir)/test-qmp-marshal.c :\
$(SRC_PATH)/qapi-schema-test.json $(SRC_PATH)/scripts/qapi-commands.py
	    $(call quiet-command,$(PYTHON) $(SRC_PATH)/scripts/qapi-commands.py -o "$(qapi-dir)" -p "test-" < $<, "  GEN   $@")

$(qapi-dir)/qga-qapi-types.c $(qapi-dir)/qga-qapi-types.h :\
$(SRC_PATH)/qapi-schema-guest.json $(SRC_PATH)/scripts/qapi-types.py
	$(call quiet-command,$(PYTHON) $(SRC_PATH)/scripts/qapi-types.py -o "$(qapi-dir)" -p "qga-" < $<, "  GEN   $@")
$(qapi-dir)/qga-qapi-visit.c $(qapi-dir)/qga-qapi-visit.h :\
$(SRC_PATH)/qapi-schema-guest.json $(SRC_PATH)/scripts/qapi-visit.py
	$(call quiet-command,$(PYTHON) $(SRC_PATH)/scripts/qapi-visit.py -o "$(qapi-dir)" -p "qga-" < $<, "  GEN   $@")
$(qapi-dir)/qga-qmp-commands.h $(qapi-dir)/qga-qmp-marshal.c :\
$(SRC_PATH)/qapi-schema-guest.json $(SRC_PATH)/scripts/qapi-commands.py
	$(call quiet-command,$(PYTHON) $(SRC_PATH)/scripts/qapi-commands.py -o "$(qapi-dir)" -p "qga-" < $<, "  GEN   $@")

qapi-types.c qapi-types.h :\
$(SRC_PATH)/qapi-schema.json $(SRC_PATH)/scripts/qapi-types.py
	$(call quiet-command,$(PYTHON) $(SRC_PATH)/scripts/qapi-types.py -o "." < $<, "  GEN   $@")
qapi-visit.c qapi-visit.h :\
$(SRC_PATH)/qapi-schema.json $(SRC_PATH)/scripts/qapi-visit.py
	$(call quiet-command,$(PYTHON) $(SRC_PATH)/scripts/qapi-visit.py -o "."  < $<, "  GEN   $@")
qmp-commands.h qmp-marshal.c :\
$(SRC_PATH)/qapi-schema.json $(SRC_PATH)/scripts/qapi-commands.py
	$(call quiet-command,$(PYTHON) $(SRC_PATH)/scripts/qapi-commands.py -m -o "." < $<, "  GEN   $@")

test-visitor.o: $(addprefix $(qapi-dir)/, test-qapi-types.c test-qapi-types.h test-qapi-visit.c test-qapi-visit.h) $(qapi-obj-y)
test-visitor: test-visitor.o $(qobject-obj-y) $(qapi-obj-y) $(tools-obj-y) $(qapi-dir)/test-qapi-visit.o $(qapi-dir)/test-qapi-types.o

test-qmp-commands.o: $(addprefix $(qapi-dir)/, test-qapi-types.c test-qapi-types.h test-qapi-visit.c test-qapi-visit.h test-qmp-marshal.c test-qmp-commands.h) $(qapi-obj-y)
test-qmp-commands: test-qmp-commands.o $(qobject-obj-y) $(qapi-obj-y) $(tools-obj-y) $(qapi-dir)/test-qapi-visit.o $(qapi-dir)/test-qapi-types.o $(qapi-dir)/test-qmp-marshal.o module.o

QGALIB_OBJ=$(addprefix $(qapi-dir)/, qga-qapi-types.o qga-qapi-visit.o qga-qmp-marshal.o)
QGALIB_GEN=$(addprefix $(qapi-dir)/, qga-qapi-types.h qga-qapi-visit.h qga-qmp-commands.h)
$(QGALIB_OBJ): $(QGALIB_GEN) $(GENERATED_HEADERS)
$(qga-obj-y) qemu-ga.o: $(QGALIB_GEN) $(GENERATED_HEADERS)

qemu-ga$(EXESUF): qemu-ga.o $(qga-obj-y) $(qapi-obj-y) $(tools-obj-y) $(qobject-obj-y) $(version-obj-y) $(QGALIB_OBJ)

QEMULIBS=libhw32 libhw64 libuser libdis libdis-user

clean:
# avoid old build problems by removing potentially incorrect old files
	rm -f config.mak op-i386.h opc-i386.h gen-op-i386.h op-arm.h opc-arm.h gen-op-arm.h
	rm -f qemu-options.def
	rm -f *.o *.d *.a *.lo $(TOOLS) $(CHECKS) qemu-ga TAGS cscope.* *.pod *~ */*~
	rm -Rf .libs
	rm -f slirp/*.o slirp/*.d audio/*.o audio/*.d block/*.o block/*.d net/*.o net/*.d fsdev/*.o fsdev/*.d ui/*.o ui/*.d qapi/*.o qapi/*.d qga/*.o qga/*.d
	rm -f qemu-img-cmds.h
	rm -f trace/*.o trace/*.d
	rm -f trace.c trace.h trace.c-timestamp trace.h-timestamp
	rm -f trace-dtrace.dtrace trace-dtrace.dtrace-timestamp
	rm -f trace-dtrace.h trace-dtrace.h-timestamp
	rm -f $(GENERATED_SOURCES)
	rm -rf $(qapi-dir)
	$(MAKE) -C tests clean
	for d in $(ALL_SUBDIRS) $(QEMULIBS) libcacard; do \
	if test -d $$d; then $(MAKE) -C $$d $@ || exit 1; fi; \
	rm -f $$d/qemu-options.def; \
        done

distclean: clean
	rm -f config-host.mak config-host.h* config-host.ld $(DOCS) qemu-options.texi qemu-img-cmds.texi qemu-monitor.texi
	rm -f config-all-devices.mak
	rm -f roms/seabios/config.mak roms/vgabios/config.mak
	rm -f qemu-doc.info qemu-doc.aux qemu-doc.cp qemu-doc.cps qemu-doc.dvi
	rm -f qemu-doc.fn qemu-doc.fns qemu-doc.info qemu-doc.ky qemu-doc.kys
	rm -f qemu-doc.log qemu-doc.pdf qemu-doc.pg qemu-doc.toc qemu-doc.tp
	rm -f qemu-doc.vr
	rm -f config.log
	rm -f qemu-tech.info qemu-tech.aux qemu-tech.cp qemu-tech.dvi qemu-tech.fn qemu-tech.info qemu-tech.ky qemu-tech.log qemu-tech.pdf qemu-tech.pg qemu-tech.toc qemu-tech.tp qemu-tech.vr
	for d in $(TARGET_DIRS) $(QEMULIBS); do \
	rm -rf $$d || exit 1 ; \
        done

KEYMAPS=da     en-gb  et  fr     fr-ch  is  lt  modifiers  no  pt-br  sv \
ar      de     en-us  fi  fr-be  hr     it  lv  nl         pl  ru     th \
common  de-ch  es     fo  fr-ca  hu     ja  mk  nl-be      pt  sl     tr

ifdef INSTALL_BLOBS
BLOBS=bios.bin sgabios.bin vgabios.bin vgabios-cirrus.bin \
vgabios-stdvga.bin vgabios-vmware.bin vgabios-qxl.bin \
ppc_rom.bin openbios-sparc32 openbios-sparc64 openbios-ppc \
pxe-e1000.rom pxe-eepro100.rom pxe-ne2k_pci.rom \
pxe-pcnet.rom pxe-rtl8139.rom pxe-virtio.rom \
bamboo.dtb petalogix-s3adsp1800.dtb petalogix-ml605.dtb \
mpc8544ds.dtb \
multiboot.bin linuxboot.bin \
s390-zipl.rom \
spapr-rtas.bin slof.bin \
palcode-clipper
BLOBS += vapic.bin
else
BLOBS=
endif

install-doc: $(DOCS)
	$(INSTALL_DIR) "$(DESTDIR)$(docdir)"
	$(INSTALL_DATA) qemu-doc.html  qemu-tech.html "$(DESTDIR)$(docdir)"
ifdef CONFIG_POSIX
	$(INSTALL_DIR) "$(DESTDIR)$(mandir)/man1"
	$(INSTALL_DATA) qemu.1 qemu-img.1 "$(DESTDIR)$(mandir)/man1"
	$(INSTALL_DIR) "$(DESTDIR)$(mandir)/man8"
	$(INSTALL_DATA) qemu-nbd.8 "$(DESTDIR)$(mandir)/man8"
endif

install-sysconfig:
	$(INSTALL_DIR) "$(DESTDIR)$(sysconfdir)/qemu"
	$(INSTALL_DATA) $(SRC_PATH)/sysconfigs/target/target-x86_64.conf "$(DESTDIR)$(sysconfdir)/qemu"

install: all $(if $(BUILD_DOCS),install-doc) install-sysconfig
	$(INSTALL_DIR) "$(DESTDIR)$(bindir)"
ifneq ($(TOOLS),)

=== pc-bios/optionrom/Makefile ===
all: build-all
# Dummy command so that make thinks it has done something
	@true

include ../../config-host.mak
include $(SRC_PATH)/rules.mak

$(call set-vpath, $(SRC_PATH)/pc-bios/optionrom)

.PHONY : all clean build-all

CFLAGS := -Wall -Wstrict-prototypes -Werror -fomit-frame-pointer -fno-builtin
CFLAGS += -I$(SRC_PATH)
CFLAGS += $(call cc-option, $(CFLAGS), -fno-stack-protector)
QEMU_CFLAGS = $(CFLAGS)

build-all: multiboot.bin linuxboot.bin

build-all: vapic.bin

%.img: %.o
	$(call quiet-command,$(LD) -Ttext 0 -e _start -s -o $@ $<,"  Building $(TARGET_DIR)$@")

%.raw: %.img
	$(call quiet-command,$(OBJCOPY) -O binary -j .text $< $@,"  Building $(TARGET_DIR)$@")

%.bin: %.raw
	$(call quiet-command,$(SHELL) $(SRC_PATH)/scripts/signrom.sh $< $@,"  Signing $(TARGET_DIR)$@")

clean:
	rm -f *.o *.d *.raw *.img *.bin *~

## qemu-kvm 1.0-release

=== debian/changelog ===
qemu-kvm (1.0-release-5ubuntu9) precise; urgency=high

  * Build based on qemu-kvm-1.0 Adding libattr1-dev
    to debian/control dependencies LP: #782973
    Top 18 USB redirection patches been extracted from 
      http://cgit.freedesktop.org/~jwrdegoede/qemu/log/?h=qemu-kvm-1.0-usbredir 
    applied to image obtained via git://git.kernel.org/pub/scm/virt/kvm/qemu-kvm.git,
    checkout tag qemu-kvm-1.0.
    Creating package qemu-utils to dual boot with Xen 4.1

 -- Boris Derzhavets  <bderzhavets@yahoo.com>  Sun, 01 Jan 2012 13:32:54 +0530

qemu-kvm (0.14.0+noroms-0ubuntu4) natty; urgency=low

  *LP: #719174
   Typo corrected

 -- Bhaveek Desai <bhaveekdesai.os@gmail.com>  Fri, 18 Mar 2011 21:06:54 +0530

qemu-kvm (0.14.0+noroms-0ubuntu3) natty; urgency=low

  * debian/qemu-common.links: symlink all of the vgabios bin files into
    the qemu expected paths, LP: #736351

 -- Dustin Kirkland <kirkland@ubuntu.com>  Wed, 16 Mar 2011 21:20:14 -0500

qemu-kvm (0.14.0+noroms-0ubuntu2) natty; urgency=low

  * debian/qemu-kvm.default: per popular request, reduce the ksm sleep
    milliseconds to 200ms, LP: #578930

 -- Dustin Kirkland <kirkland@ubuntu.com>  Wed, 09 Mar 2011 11:21:40 +0000

qemu-kvm (0.14.0+noroms-0ubuntu1) natty; urgency=low

  * Merge qemu-kvm 0.14.0
  * debian/rules: get DEB_HOST_ARCH from dpkg-architecture.  Otherwise
    it is empty, resulting in kvm being not enabled
  * debian/rules: re-enable parallel builds

 -- Serge Hallyn <serge.hallyn@ubuntu.com>  Tue, 08 Mar 2011 10:10:49 -0600

qemu-kvm (0.14.0~rc1+noroms-0ubuntu4) natty; urgency=low

  * Apply spice-qxl-locking-fix-for-qemu-kvm.patch to fix bug with -qxl.
    (LP: #723871)

 -- Serge Hallyn <serge.hallyn@ubuntu.com>  Tue, 01 Mar 2011 11:12:44 -0600

qemu-kvm (0.14.0~rc1+noroms-0ubuntu3) natty; urgency=low

  * control: fix description of dummy qemu and kvm packages to mention
    "qemu-kvm" and not "kvm-qemu".
  * control: add armhf in the list of architectures along armel.
  * rules: test whether DEB_HOST_ARCH_CPU is arm instead of testing whether
    DEB_HOST_ARCH is arm or armel; this fixes support for armhf.

 -- Loïc Minier <loic.minier@linaro.org>  Wed, 16 Feb 2011 09:58:03 +0100

qemu-kvm (0.14.0~rc1+noroms-0ubuntu2) natty; urgency=low

  * debian/rules: place --fno-var-tracking back into CFLAGS for arm, so
    as to prevent out of memory. (LP: #693341)

 -- Serge Hallyn <serge.hallyn@ubuntu.com>  Tue, 15 Feb 2011 20:37:56 -0600

qemu-kvm (0.14.0~rc1+noroms-0ubuntu1) natty; urgency=low

  [ Serge Hallyn ]
  * Merge qemu-kvm 0.14.0-rc1
  * removed all rom's
  * removed tests/pi_10.com as it's binary data
  * removed 697197-fix-vnc-password-semantics.patch in favor of upstream fix
  * removed caps-lock-key-up-event.patch - upstream commit
    9a121a2fbf88dd1bc869b1ac2449dc12c27cccfa is supposed to fix it
    - bdrung to verify
  * removed 1000-undo-earlier-static.patch
    - re-add if build fails - but we no longer do static build
  * removed 2000-vmmouse-adapt-to-mouse-handler-changes.patch, now upstream
  * removed arm patches - qemu-kvm now only offers x86 and ppc emulation
    - qemu-user provides armel
  * kvmtrace_format is now shipped with different tree.

  [ Dustin Kirkland ]
  * Re-roll tarball, adding ~rc1 to version, so that the official GA release
    will supercede these rc's
  * debian/control: bump standards versions, remove redundant depends on
    adduser, update section to misc
  * debian/rules: drop qemu-system-ppc64 from the build, as this is in
    qemu-linaro now, LP: #717690
  * debian/copyright: embed the BSD license, per lintian

  [ Steve Langasek ]
  * debian/rules: drop the binfmt-misc handling; we're not building any
    static user binaries from this source, so this is just noise.
  * debian/rules: $INSTALL_PROGRAM is never set, so modifying it is
    pointless.  Delete this as well.
  * build qemu-kvm package on all archs; this is the authoritative package
    for x86 system emulators, so we only have to deal with the bios
    dependencies in one place.
  * don't run 'make install' in kvm/libkvm directory, this is a no-op anyway.
 
 -- Serge Hallyn <serge.hallyn@ubuntu.com>  Mon, 14 Feb 2011 07:50:16 -0600

qemu-kvm (0.13.0+noroms-0ubuntu15) natty; urgency=low

  [ Dustin Kirkland ]
  * debian/binfmts/qemu-alpha, debian/binfmts/qemu-arm,
    debian/binfmts/qemu-armeb, debian/binfmts/qemu-cris,
    debian/binfmts/qemu-i386, debian/binfmts/qemu-m68k,
    debian/binfmts/qemu-microblaze, debian/binfmts/qemu-mips,
    debian/binfmts/qemu-mipsel, debian/binfmts/qemu-ppc,
    debian/binfmts/qemu-ppc64, debian/binfmts/qemu-ppc64abi32,
    debian/binfmts/qemu-sh4, debian/binfmts/qemu-sh4eb,
    debian/binfmts/qemu-sparc, debian/binfmts/qemu-sparc32plus,
    debian/binfmts/qemu-sparc64, debian/binfmts/qemu-x86_64,
    debian/control, debian/qemu-arm-static.postinst, debian/qemu-kvm-
    extras.dirs, debian/qemu-kvm-extras.links, debian/qemu-kvm-extras-
    static.dirs, debian/qemu-kvm-extras-static.postinst, debian/qemu-
    kvm-extras-static.postrm, debian/qemu-kvm-extras-static.preinst,
    debian/qemu-kvm-extras-static.prerm, debian/qemu-kvm-extras-
    static.sysctl, debian/qemu-kvm-extras-static.sysctl.amd64,
    debian/rules, === removed directory debian/binfmts:
    - massive simplification of the qemu-kvm build, now that qemu-linaro
      provides all of the system emulation for non-accelerated architectures,
      ie, those other than [i386, amd64, powerpc]
    - specify the i386, amd64, ppc64 targets

  [ Steve Langasek ]
  * Rename qemu-user manpage to qemu-kvm so that qemu-linaro can take over
    the more generic name.

 -- Dustin Kirkland <kirkland@ubuntu.com>  Fri, 11 Feb 2011 15:07:04 -0600

qemu-kvm (0.13.0+noroms-0ubuntu14) natty; urgency=low

  * Pass -fno-var-tracking on armel to hopefully reduce memory consumption.
    (LP: #693341)

 -- Serge Hallyn <serge.hallyn@ubuntu.com>  Tue, 08 Feb 2011 14:41:39 -0600

qemu-kvm (0.13.0+noroms-0ubuntu13) natty; urgency=low



=== debian/control ===
Source: qemu-kvm
Section: misc
Priority: optional
Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
Build-Depends: bcc,
               bzip2,
               debhelper (>= 7),
               device-tree-compiler [powerpc],
               iasl,
               libaio-dev,
               libasound2-dev,
               libattr1-dev,
               libcurl4-gnutls-dev,
               libgnutls-dev,
               libncurses5-dev,
               libpci-dev,
               libpixman-1-dev,
               libpulse-dev,
               libsasl2-dev,
               libsdl1.2-dev (>= 1.2.14),
               libssl-dev,
               libx11-dev,
               nasm,
               perl,
               pkg-config,
               quilt (>= 0.40),
               libspice-server-dev (>= 0.9.1),
               libspice-protocol-dev (>= 0.9.0),
               sysv-rc (>= 2.86.ds1-14.1ubuntu2),
               texi2html,
               texinfo,
               uuid-dev,
               zlib1g-dev,
               ipxe,
               libgudev-1.0-dev, 
               libusb-1.0-0-dev, 
               libusbredir-dev
Standards-Version: 3.9.1
Homepage: http://www.linux-kvm.org

Package: qemu-kvm
Architecture: any
Depends: bridge-utils,
         iproute,
         python,
         qemu-common (>= ${source:Version}),
         ${misc:Depends},
         ${shlibs:Depends}
Pre-Depends: adduser
Provides: kvm, qemu
Conflicts: kvm (<< 1:84+dfsg-0ubuntu16+0.11.0), kvm-data, qemu (<< 0.11.0-0ubuntu5)
Replaces: kvm (<< 1:84+dfsg-0ubuntu16+0.11.0), kvm-data, qemu
Breaks: udev (<< 136-1)
Description: Full virtualization on i386 and amd64 hardware
 Using KVM, one can run multiple virtual PCs, each running unmodified Linux or
 Windows images. Each virtual machine has private virtualized hardware: a
 network card, disk, graphics adapter, etc.
 .
 KVM (for Kernel-based Virtual Machine) is a full virtualization solution for
 Linux hosts on x86 (32 and 64-bit) hardware.
 .
 KVM is intended for systems where the processor has hardware support for
 virtualization, see below for details.  All combinations of 32-bit and 64-bit
 host and guest systems are supported, except 64-bit guests on 32-bit hosts.
 .
 KVM requires your system to support hardware virtualization, provided by AMD's
 SVM capability or Intel's VT. To find out if your processor has the necessary
 support:
 .
   egrep "flags.*:.*(svm|vmx)" /proc/cpuinfo
 .
 If it prints anything, the processor provides hardware virtualization
 support and is suitable for use with KVM.  Without hardware support, you can
 use qemu emulation instead.
 .
 KVM consists of two loadable kernel modules (kvm.ko and either kvm-amd.ko or
 kvm-intel.ko) and a userspace component. This package contains the userspace
 component, and you can get the kernel modules from the standard kernel images.
 .
 This package contains support for running virtualized and emulated x86 and
 x86-64 machines only.  Support for other architectures is provided by the
 qemu-linaro source package.

Package: qemu-utils
Architecture: any
Depends: ${misc:Depends}, ${shlibs:Depends}
Description: qemu utilities
 This package provides some utilities for which full qemu-kvm is not needed,
 in particular qemu-nbd and qemu-img.

Package: qemu-common
Architecture: all
Depends: seabios, vgabios, ${misc:Depends}, ${shlibs:Depends}
Recommends: cpu-checker
Suggests: kvm-pxe,
          mol-drivers-macosx,
          openbios-sparc,
          ubuntu-vm-builder,
          uml-utilities
Replaces: qemu-kvm (<< 0.12.3+noroms-0ubuntu1)
Description: qemu common functionality (bios, documentation, etc)
 This package pulls in the various binary bios rom blobs needed to boot
 the various emulated architectures, as well as the documentation.

Package: kvm
Architecture: amd64 armel armhf i386 powerpc sparc
Depends: qemu-kvm, ${misc:Depends}
Section: misc
Description: dummy transitional package from kvm to qemu-kvm
 This transitional package helps users transition from the kvm package to the
 qemu-kvm package.  Once this package and its dependencies are installed you
 can safely remove it.

Package: qemu
Architecture: amd64 armel armhf i386 powerpc sparc
Depends: qemu-kvm, ${misc:Depends}
Section: misc
Description: dummy transitional package from qemu to qemu-kvm
 This transitional package helps users transition from the qemu package to the
 qemu-kvm package.  Once this package and its dependencies are installed you
 can safely remove it.

=== debian/rules ===
#!/usr/bin/make -f

include /usr/share/quilt/quilt.make

DEB_HOST_GNU_TYPE   ?= $(shell dpkg-architecture -qDEB_HOST_GNU_TYPE)
DEB_HOST_ARCH_CPU   ?= $(shell dpkg-architecture -qDEB_HOST_ARCH_CPU)
DEB_HOST_ARCH_OS    ?= $(shell dpkg-architecture -qDEB_HOST_ARCH_OS)
DEB_HOST_ARCH       ?= $(shell dpkg-architecture -qDEB_HOST_ARCH)
DEB_BUILD_GNU_TYPE  ?= $(shell dpkg-architecture -qDEB_BUILD_GNU_TYPE)
DEB_BUILD_ARCH      ?= $(shell dpkg-architecture -qDEB_BUILD_ARCH)

# Handle DEB_BUILD_OPTIONS=parallel=N
, := ,
ifneq (,$(filter parallel=%,$(subst $(,), ,$(DEB_BUILD_OPTIONS))))
  NUMJOBS := $(patsubst parallel=%,%,$(filter parallel=%,$(subst $(,), ,$(DEB_BUILD_OPTIONS))))
  MAKEFLAGS += -j$(NUMJOBS)
endif

ifeq ($(DEB_HOST_ARCH_OS),linux)
# Note: We differ from Debian here by favoring the pulseaudio driver, since that's default in Ubuntu.
#       Users override this when calling qemu by exporting the environment variable QEMU_AUDIO_DRV.
conf_arch += --audio-drv-list="pa,alsa,sdl,oss" --enable-vnc-sasl --enable-docs
endif
ifeq ($(DEB_HOST_ARCH_OS),kfreebsd)
conf_arch += --audio-drv-list=oss,sdl,pa
endif
ifeq ($(filter $(DEB_HOST_ARCH),i386 amd64 lpia),)
conf_arch += --disable-kvm
endif

debsrc_ver := $(shell dpkg-parsechangelog | sed -n -e 's/^Version: //p' | perl -pe 's/-[^-]+$$//o')
debian_rev := $(shell dpkg-parsechangelog | sed -n -e 's/^Version: //p' | perl -pe 's/.*-//o')

CFLAGS += -Wall -g -O$(if $(findstring noopt,$(DEB_BUILD_OPTIONS)),0,2)

ifeq ($(DEB_HOST_ARCH_CPU),arm)
CFLAGS += -fno-var-tracking
endif

config-host.mak: $(QUILT_STAMPFN)
	dh_testdir
	./configure \
	    --target-list="x86_64-softmmu i386-softmmu x86_64-linux-user i386-linux-user" \
	    --prefix=/usr \
	    --interp-prefix=/etc/qemu-binfmt/%M \
	    --disable-blobs \
	    --disable-strip \
            --enable-spice \
            --enable-usb-redir \
	    $(conf_arch)

build: build-stamp
build-stamp: config-host.mak
	dh_testdir
	touch $@

clean:
	dh_testdir
	rm -f install-stamp build-stamp
	# Clean up some upstream build cruft
	rm -f pc-bios/\*.bin pc-bios/\*.dtb pc-bios/openbios-\* roms/seabios/Makefile roms/vgabios/Makefile
	[ ! -f config-host.mak ] || $(MAKE) distclean
#	$(MAKE) -f debian/rules unpatch
	rm -f kvm/extboot/*.o kvm/extboot/extboot.img  kvm/extboot/signrom config.mak kvm/user/config.mak kvm/user/test/lib/.*.d kvm/user/test/lib/*/.*.d kvm/bios/acpi-dsdt.aml kvm/bios/acpi-ssdt.aml qemu-monitor.texi
	dh_clean

install: install-stamp
install-stamp: build
	dh_testdir
	dh_testroot
	dh_clean -k
	dh_installdirs
	# Build & install normally
	$(MAKE) DESTDIR=$(CURDIR)/debian/qemu-kvm install
	mv debian/qemu-kvm/usr/bin/qemu-nbd debian/qemu-utils/usr/bin/
	mv debian/qemu-kvm/usr/bin/qemu-img debian/qemu-utils/usr/bin/
	touch $@

binary-indep:
	dh_testdir
	dh_testroot
	$(MAKE) -C pc-bios/optionrom
	dh_install -i
	dh_installdocs -X.bzr -i
	dh_installman -i
	dh_installchangelogs -i
	dh_installdebconf -i
	dh_link -i
	dh_compress -i
	dh_fixperms -i
	dh_installdeb -i
	dh_gencontrol -i
	dh_md5sums -i
	dh_builddeb -i

binary-arch: install
	dh_testdir
	dh_testroot
	dh_installdocs -s debian/changelog.qemu debian/changelog.kvm
	dh_installinit -s --no-restart-on-upgrade --error-handler=true
	dh_installman -s
	dh_installudev -s --priority=45
	dh_installchangelogs -s
	dh_install -s
	dh_strip -s
	dh_link -s
	dh_compress -s
	dh_fixperms -s
	dh_installdeb -s
	dh_shlibdeps -s
	dh_gencontrol -s -Nkvm
	dh_gencontrol -pkvm -- -v1:84+dfsg-0ubuntu16+$(debsrc_ver)+$(debian_rev)
	# Prune keymaps from qemu-kvm, as these are now in qemu-common
	rm -rf debian/qemu-kvm/usr/share/qemu/keymaps
	dh_md5sums -s
	dh_builddeb -s

binary: binary-indep binary-arch

.PHONY: build clean binary-indep binary-arch binary install

=== debian/watch ===
version=3
http://sf.net/kvm/qemu-kvm-([0-9].*)\.tar\.gz \
        debian uupdate
